/* the game logic (no view code or direct user intraction)
the game is a simple guess the word game based on mastermind
*/

#pragma once
#include <string>

// to make sytanx unreal friendly
using Fstring = std::string;
using int32 = int;

struct FBullCowCount
{
	int32 Bulls = 0;
	int32 Cows = 0;
};

enum EGuessStatus
{
	Invalid,
	OK,
	Not_Isogram,
	Wrong_Length,
	Not_Lowercase,
};

class FBullCowGame
{
public:
	FBullCowGame(); //constructor

	int32 GetMaxTries() const;
	int32 GetCurrentTries() const;
	int32 GetHiddenWorldLength() const;
	bool IsGameWon() const;
	EGuessStatus CheckGuessValidity(Fstring) const;


	void Reset();
	FBullCowCount SubmitValidGuess(Fstring);

private:
	// see constructor initialization
	bool bGameIsWon;
	int32 MyCurrentTry;
	Fstring MyHiddenWord;
	bool IsIsogram(Fstring) const;
	bool IsLowerCase(Fstring) const;
};
