/* This is console executable, that makes use of the BullCow class
This acs as a view in MVC pattern, and is responsible and is responsible
for all user intractions. for game logic see the FBullCowGame class.
*/
#pragma once

#include <iostream>
#include <string>
#include "FBullCowGame.h"

// to make sytanx unreal friendly
using FText = std::string;
using int32 = int;

// funtion prototypes as outside the class
void PrintIntro();
void PlayGame();
FText GetValidGuess();
bool AskToPlayAgain();
void PrintGameSummary();

FBullCowGame BCGame; // instanciate a new game, witch we re-use across plays

int main()
{
	bool bPlayAgain = false;
	do
	{
		PrintIntro();
		PlayGame();
		bPlayAgain = AskToPlayAgain();
	} while (bPlayAgain);
	return 0; // exit the application
}

void PrintIntro()
{
	std::cout << "  _______   __  __   __       __       ______   AND   ______   ______   __ __ __   ______" << std::endl;
	std::cout << "/_______/\\ /_/\\/_/\\ /_/\\     /_/\\     /_____/\\       /_____/\\ /_____/\\ /_//_//_/\\ /_____/\\     " << std::endl;
	std::cout << "\\::: _  \\ \\\\:\\ \\:\\ \\\\:\\ \\    \\:\\ \\    \\::::_\\/_      \\:::__\\/ \\:::_ \\ \\\\:\\\\:\\\\:\\ \\\\::::_\\/_    " << std::endl;
	std::cout << " \\::(_)  \\/_\\:\\ \\:\\ \\\\:\\ \\    \\:\\ \\    \\:\\/___/\\      \\:\\ \\  __\\:\\ \\ \\ \\\\:\\\\:\\\\:\\ \\\\:\\/___/\\   " << std::endl;
	std::cout << "  \\::  _  \\ \\\\:\\ \\:\\ \\\\:\\ \\____\\:\\ \\____\\_::._\\:\\      \\:\\ \\/_/\\\\:\\ \\ \\ \\\\:\\\\:\\\\:\\ \\\\_::._\\:\\ " << std::endl;
	std::cout << "   \\::(_)  \\ \\\\:\\_\\:\\ \\\\:\\/___/\\\\:\\/___/\\ /____\\:\\      \\:\\_\\ \\ \\\\:\\_\\ \\ \\\\:\\\\:\\\\:\\ \\ /____\\:\\" << std::endl;
	std::cout << "    \\_______\\/ \\_____\\/ \\_____\\/ \\_____\\/ \\_____\\/       \\_____\\/ \\_____\\/ \\_______\\/ \\_____\\/ " << std::endl;
    std::cout << "					A fun game by Devloger.io\n" << std::endl;
	return;
}

// plays a single game to completion
void PlayGame()
{
	std::cout << "Can you guess the " << BCGame.GetHiddenWorldLength() << " letter isogram I'm thinking of?\n";
	BCGame.Reset();
	int32 MaxTries = BCGame.GetMaxTries();

	// loop for asking for guesses while game
	// is NOT won and there are still tries remaining
	while (!BCGame.IsGameWon() && BCGame.GetCurrentTries() <= MaxTries)
	{
		Fstring Guess = GetValidGuess();
		FBullCowCount BullCowCount = BCGame.SubmitValidGuess(Guess);
		std::cout << "Bulls = " << BullCowCount.Bulls << ". Cows = " << BullCowCount.Cows << "\n\n\n";
	}
	PrintGameSummary();
	return;
}

void PrintGameSummary ()
{
	if(BCGame.IsGameWon())
	{
		std::cout << "GREAT! >> YOU WON THE GAME! <<";
	}
	else
	{
		std::cout << "OH NO! >> GAME OVER! <<";
	}
	std::cout << "\n";
	return;
}

// loop continually untill the user gives a valid guess
FText GetValidGuess() 
{
	EGuessStatus Status = EGuessStatus::Invalid;
	FText Guess = "";
	do
	{
		int32 CurrentTry = BCGame.GetCurrentTries();
		std::cout << "Try " << CurrentTry << " of " << BCGame.GetMaxTries() << ". Whats your guess? ";
		std::getline(std::cin, Guess);

		Status = BCGame.CheckGuessValidity(Guess);
		switch (Status)
		{
		case Not_Isogram:
			std::cout << "Please enter a word without repeating letters.\n";
			break;
		case Wrong_Length:
			std::cout << "Please enter a " << BCGame.GetHiddenWorldLength() << " letter word.\n";
			break;
		case Not_Lowercase:
			std::cout << "Please enter all lower case letters.\n";
			break;
		default:
			// assume the guess is valid
			break;
		}
	} while (Status != EGuessStatus::OK); // keep looping until we get no errors
	return Guess;
}

bool AskToPlayAgain()
{
	std::cout << "Do you want to play again with the same hiden word (y/n)? ";
	FText response = "";
	std::getline(std::cin, response);
	return (response[0] == 'y') || (response[0] == 'Y');
}
